"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetApplicationResponse = exports.GetApplicationRequest = exports.EnvironmentVpc = exports.EnvironmentSummary = exports.DeleteServiceResponse = exports.DeleteServiceRequest = exports.DeleteRouteResponse = exports.DeleteRouteRequest = exports.DeleteResourcePolicyResponse = exports.DeleteResourcePolicyRequest = exports.DeleteEnvironmentResponse = exports.DeleteEnvironmentRequest = exports.DeleteApplicationResponse = exports.DeleteApplicationRequest = exports.CreateServiceResponse = exports.ServiceState = exports.CreateServiceRequest = exports.UrlEndpointInput = exports.LambdaEndpointInput = exports.ServiceEndpointType = exports.CreateRouteResponse = exports.RouteState = exports.CreateRouteRequest = exports.UriPathRouteInput = exports.HttpMethod = exports.RouteActivationState = exports.RouteType = exports.CreateEnvironmentResponse = exports.EnvironmentState = exports.CreateEnvironmentRequest = exports.NetworkFabricType = exports.ValidationException = exports.ThrottlingException = exports.ServiceQuotaExceededException = exports.ResourceNotFoundException = exports.InternalServerException = exports.CreateApplicationResponse = exports.CreateApplicationRequest = exports.ConflictException = exports.ApplicationSummary = exports.ProxyType = exports.ErrorResponse = exports.ErrorResourceType = exports.ErrorCode = exports.ApplicationState = exports.ApiGatewayProxySummary = exports.ApiGatewayProxyInput = exports.ApiGatewayProxyConfig = exports.ApiGatewayEndpointType = exports.AccessDeniedException = void 0;
exports.UntagResourceResponse = exports.UntagResourceRequest = exports.TagResourceResponse = exports.TagResourceRequest = exports.PutResourcePolicyResponse = exports.PutResourcePolicyRequest = exports.ListTagsForResourceResponse = exports.ListTagsForResourceRequest = exports.ListServicesResponse = exports.ServiceSummary = exports.UrlEndpointSummary = exports.ListServicesRequest = exports.ListRoutesResponse = exports.RouteSummary = exports.ListRoutesRequest = exports.ListEnvironmentVpcsResponse = exports.ListEnvironmentVpcsRequest = exports.ListEnvironmentsResponse = exports.ListEnvironmentsRequest = exports.ListApplicationsResponse = exports.ListApplicationsRequest = exports.LambdaEndpointSummary = exports.InvalidResourcePolicyException = exports.GetServiceResponse = exports.UrlEndpointConfig = exports.LambdaEndpointConfig = exports.GetServiceRequest = exports.GetRouteResponse = exports.GetRouteRequest = exports.GetResourcePolicyResponse = exports.GetResourcePolicyRequest = exports.GetEnvironmentResponse = exports.GetEnvironmentRequest = void 0;
const smithy_client_1 = require("@aws-sdk/smithy-client");
const MigrationHubRefactorSpacesServiceException_1 = require("./MigrationHubRefactorSpacesServiceException");
class AccessDeniedException extends MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException {
    constructor(opts) {
        super({
            name: "AccessDeniedException",
            $fault: "client",
            ...opts,
        });
        this.name = "AccessDeniedException";
        this.$fault = "client";
        Object.setPrototypeOf(this, AccessDeniedException.prototype);
        this.Message = opts.Message;
    }
}
exports.AccessDeniedException = AccessDeniedException;
var ApiGatewayEndpointType;
(function (ApiGatewayEndpointType) {
    ApiGatewayEndpointType["PRIVATE"] = "PRIVATE";
    ApiGatewayEndpointType["REGIONAL"] = "REGIONAL";
})(ApiGatewayEndpointType = exports.ApiGatewayEndpointType || (exports.ApiGatewayEndpointType = {}));
var ApiGatewayProxyConfig;
(function (ApiGatewayProxyConfig) {
    ApiGatewayProxyConfig.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ApiGatewayProxyConfig = exports.ApiGatewayProxyConfig || (exports.ApiGatewayProxyConfig = {}));
var ApiGatewayProxyInput;
(function (ApiGatewayProxyInput) {
    ApiGatewayProxyInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ApiGatewayProxyInput = exports.ApiGatewayProxyInput || (exports.ApiGatewayProxyInput = {}));
var ApiGatewayProxySummary;
(function (ApiGatewayProxySummary) {
    ApiGatewayProxySummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ApiGatewayProxySummary = exports.ApiGatewayProxySummary || (exports.ApiGatewayProxySummary = {}));
var ApplicationState;
(function (ApplicationState) {
    ApplicationState["ACTIVE"] = "ACTIVE";
    ApplicationState["CREATING"] = "CREATING";
    ApplicationState["DELETING"] = "DELETING";
    ApplicationState["FAILED"] = "FAILED";
    ApplicationState["UPDATING"] = "UPDATING";
})(ApplicationState = exports.ApplicationState || (exports.ApplicationState = {}));
var ErrorCode;
(function (ErrorCode) {
    ErrorCode["INVALID_RESOURCE_STATE"] = "INVALID_RESOURCE_STATE";
    ErrorCode["NOT_AUTHORIZED"] = "NOT_AUTHORIZED";
    ErrorCode["REQUEST_LIMIT_EXCEEDED"] = "REQUEST_LIMIT_EXCEEDED";
    ErrorCode["RESOURCE_CREATION_FAILURE"] = "RESOURCE_CREATION_FAILURE";
    ErrorCode["RESOURCE_DELETION_FAILURE"] = "RESOURCE_DELETION_FAILURE";
    ErrorCode["RESOURCE_IN_USE"] = "RESOURCE_IN_USE";
    ErrorCode["RESOURCE_LIMIT_EXCEEDED"] = "RESOURCE_LIMIT_EXCEEDED";
    ErrorCode["RESOURCE_NOT_FOUND"] = "RESOURCE_NOT_FOUND";
    ErrorCode["RESOURCE_RETRIEVAL_FAILURE"] = "RESOURCE_RETRIEVAL_FAILURE";
    ErrorCode["RESOURCE_UPDATE_FAILURE"] = "RESOURCE_UPDATE_FAILURE";
    ErrorCode["SERVICE_ENDPOINT_HEALTH_CHECK_FAILURE"] = "SERVICE_ENDPOINT_HEALTH_CHECK_FAILURE";
    ErrorCode["STATE_TRANSITION_FAILURE"] = "STATE_TRANSITION_FAILURE";
})(ErrorCode = exports.ErrorCode || (exports.ErrorCode = {}));
var ErrorResourceType;
(function (ErrorResourceType) {
    ErrorResourceType["API_GATEWAY"] = "API_GATEWAY";
    ErrorResourceType["APPLICATION"] = "APPLICATION";
    ErrorResourceType["ENVIRONMENT"] = "ENVIRONMENT";
    ErrorResourceType["IAM_ROLE"] = "IAM_ROLE";
    ErrorResourceType["LAMBDA"] = "LAMBDA";
    ErrorResourceType["LOAD_BALANCER_LISTENER"] = "LOAD_BALANCER_LISTENER";
    ErrorResourceType["NLB"] = "NLB";
    ErrorResourceType["RESOURCE_SHARE"] = "RESOURCE_SHARE";
    ErrorResourceType["ROUTE"] = "ROUTE";
    ErrorResourceType["ROUTE_TABLE"] = "ROUTE_TABLE";
    ErrorResourceType["SECURITY_GROUP"] = "SECURITY_GROUP";
    ErrorResourceType["SERVICE"] = "SERVICE";
    ErrorResourceType["SUBNET"] = "SUBNET";
    ErrorResourceType["TARGET_GROUP"] = "TARGET_GROUP";
    ErrorResourceType["TRANSIT_GATEWAY"] = "TRANSIT_GATEWAY";
    ErrorResourceType["TRANSIT_GATEWAY_ATTACHMENT"] = "TRANSIT_GATEWAY_ATTACHMENT";
    ErrorResourceType["VPC"] = "VPC";
    ErrorResourceType["VPC_ENDPOINT_SERVICE_CONFIGURATION"] = "VPC_ENDPOINT_SERVICE_CONFIGURATION";
    ErrorResourceType["VPC_LINK"] = "VPC_LINK";
})(ErrorResourceType = exports.ErrorResourceType || (exports.ErrorResourceType = {}));
var ErrorResponse;
(function (ErrorResponse) {
    ErrorResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ErrorResponse = exports.ErrorResponse || (exports.ErrorResponse = {}));
var ProxyType;
(function (ProxyType) {
    ProxyType["API_GATEWAY"] = "API_GATEWAY";
})(ProxyType = exports.ProxyType || (exports.ProxyType = {}));
var ApplicationSummary;
(function (ApplicationSummary) {
    ApplicationSummary.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(ApplicationSummary = exports.ApplicationSummary || (exports.ApplicationSummary = {}));
class ConflictException extends MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException {
    constructor(opts) {
        super({
            name: "ConflictException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConflictException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConflictException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
        this.ResourceType = opts.ResourceType;
    }
}
exports.ConflictException = ConflictException;
var CreateApplicationRequest;
(function (CreateApplicationRequest) {
    CreateApplicationRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(CreateApplicationRequest = exports.CreateApplicationRequest || (exports.CreateApplicationRequest = {}));
var CreateApplicationResponse;
(function (CreateApplicationResponse) {
    CreateApplicationResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(CreateApplicationResponse = exports.CreateApplicationResponse || (exports.CreateApplicationResponse = {}));
class InternalServerException extends MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException {
    constructor(opts) {
        super({
            name: "InternalServerException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServerException";
        this.$fault = "server";
        Object.setPrototypeOf(this, InternalServerException.prototype);
        this.Message = opts.Message;
    }
}
exports.InternalServerException = InternalServerException;
class ResourceNotFoundException extends MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException {
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
        this.ResourceType = opts.ResourceType;
    }
}
exports.ResourceNotFoundException = ResourceNotFoundException;
class ServiceQuotaExceededException extends MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException {
    constructor(opts) {
        super({
            name: "ServiceQuotaExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "ServiceQuotaExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ServiceQuotaExceededException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
        this.ResourceType = opts.ResourceType;
        this.QuotaCode = opts.QuotaCode;
        this.ServiceCode = opts.ServiceCode;
    }
}
exports.ServiceQuotaExceededException = ServiceQuotaExceededException;
class ThrottlingException extends MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException {
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        this.name = "ThrottlingException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ThrottlingException.prototype);
        this.Message = opts.Message;
        this.QuotaCode = opts.QuotaCode;
        this.ServiceCode = opts.ServiceCode;
        this.RetryAfterSeconds = opts.RetryAfterSeconds;
    }
}
exports.ThrottlingException = ThrottlingException;
class ValidationException extends MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException {
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ValidationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ValidationException.prototype);
        this.Message = opts.Message;
    }
}
exports.ValidationException = ValidationException;
var NetworkFabricType;
(function (NetworkFabricType) {
    NetworkFabricType["TRANSIT_GATEWAY"] = "TRANSIT_GATEWAY";
})(NetworkFabricType = exports.NetworkFabricType || (exports.NetworkFabricType = {}));
var CreateEnvironmentRequest;
(function (CreateEnvironmentRequest) {
    CreateEnvironmentRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(CreateEnvironmentRequest = exports.CreateEnvironmentRequest || (exports.CreateEnvironmentRequest = {}));
var EnvironmentState;
(function (EnvironmentState) {
    EnvironmentState["ACTIVE"] = "ACTIVE";
    EnvironmentState["CREATING"] = "CREATING";
    EnvironmentState["DELETING"] = "DELETING";
    EnvironmentState["FAILED"] = "FAILED";
})(EnvironmentState = exports.EnvironmentState || (exports.EnvironmentState = {}));
var CreateEnvironmentResponse;
(function (CreateEnvironmentResponse) {
    CreateEnvironmentResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(CreateEnvironmentResponse = exports.CreateEnvironmentResponse || (exports.CreateEnvironmentResponse = {}));
var RouteType;
(function (RouteType) {
    RouteType["DEFAULT"] = "DEFAULT";
    RouteType["URI_PATH"] = "URI_PATH";
})(RouteType = exports.RouteType || (exports.RouteType = {}));
var RouteActivationState;
(function (RouteActivationState) {
    RouteActivationState["ACTIVE"] = "ACTIVE";
})(RouteActivationState = exports.RouteActivationState || (exports.RouteActivationState = {}));
var HttpMethod;
(function (HttpMethod) {
    HttpMethod["DELETE"] = "DELETE";
    HttpMethod["GET"] = "GET";
    HttpMethod["HEAD"] = "HEAD";
    HttpMethod["OPTIONS"] = "OPTIONS";
    HttpMethod["PATCH"] = "PATCH";
    HttpMethod["POST"] = "POST";
    HttpMethod["PUT"] = "PUT";
})(HttpMethod = exports.HttpMethod || (exports.HttpMethod = {}));
var UriPathRouteInput;
(function (UriPathRouteInput) {
    UriPathRouteInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UriPathRouteInput = exports.UriPathRouteInput || (exports.UriPathRouteInput = {}));
var CreateRouteRequest;
(function (CreateRouteRequest) {
    CreateRouteRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(CreateRouteRequest = exports.CreateRouteRequest || (exports.CreateRouteRequest = {}));
var RouteState;
(function (RouteState) {
    RouteState["ACTIVE"] = "ACTIVE";
    RouteState["CREATING"] = "CREATING";
    RouteState["DELETING"] = "DELETING";
    RouteState["FAILED"] = "FAILED";
    RouteState["INACTIVE"] = "INACTIVE";
    RouteState["UPDATING"] = "UPDATING";
})(RouteState = exports.RouteState || (exports.RouteState = {}));
var CreateRouteResponse;
(function (CreateRouteResponse) {
    CreateRouteResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(CreateRouteResponse = exports.CreateRouteResponse || (exports.CreateRouteResponse = {}));
var ServiceEndpointType;
(function (ServiceEndpointType) {
    ServiceEndpointType["LAMBDA"] = "LAMBDA";
    ServiceEndpointType["URL"] = "URL";
})(ServiceEndpointType = exports.ServiceEndpointType || (exports.ServiceEndpointType = {}));
var LambdaEndpointInput;
(function (LambdaEndpointInput) {
    LambdaEndpointInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(LambdaEndpointInput = exports.LambdaEndpointInput || (exports.LambdaEndpointInput = {}));
var UrlEndpointInput;
(function (UrlEndpointInput) {
    UrlEndpointInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UrlEndpointInput = exports.UrlEndpointInput || (exports.UrlEndpointInput = {}));
var CreateServiceRequest;
(function (CreateServiceRequest) {
    CreateServiceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(CreateServiceRequest = exports.CreateServiceRequest || (exports.CreateServiceRequest = {}));
var ServiceState;
(function (ServiceState) {
    ServiceState["ACTIVE"] = "ACTIVE";
    ServiceState["CREATING"] = "CREATING";
    ServiceState["DELETING"] = "DELETING";
    ServiceState["FAILED"] = "FAILED";
})(ServiceState = exports.ServiceState || (exports.ServiceState = {}));
var CreateServiceResponse;
(function (CreateServiceResponse) {
    CreateServiceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(CreateServiceResponse = exports.CreateServiceResponse || (exports.CreateServiceResponse = {}));
var DeleteApplicationRequest;
(function (DeleteApplicationRequest) {
    DeleteApplicationRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteApplicationRequest = exports.DeleteApplicationRequest || (exports.DeleteApplicationRequest = {}));
var DeleteApplicationResponse;
(function (DeleteApplicationResponse) {
    DeleteApplicationResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteApplicationResponse = exports.DeleteApplicationResponse || (exports.DeleteApplicationResponse = {}));
var DeleteEnvironmentRequest;
(function (DeleteEnvironmentRequest) {
    DeleteEnvironmentRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteEnvironmentRequest = exports.DeleteEnvironmentRequest || (exports.DeleteEnvironmentRequest = {}));
var DeleteEnvironmentResponse;
(function (DeleteEnvironmentResponse) {
    DeleteEnvironmentResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteEnvironmentResponse = exports.DeleteEnvironmentResponse || (exports.DeleteEnvironmentResponse = {}));
var DeleteResourcePolicyRequest;
(function (DeleteResourcePolicyRequest) {
    DeleteResourcePolicyRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteResourcePolicyRequest = exports.DeleteResourcePolicyRequest || (exports.DeleteResourcePolicyRequest = {}));
var DeleteResourcePolicyResponse;
(function (DeleteResourcePolicyResponse) {
    DeleteResourcePolicyResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteResourcePolicyResponse = exports.DeleteResourcePolicyResponse || (exports.DeleteResourcePolicyResponse = {}));
var DeleteRouteRequest;
(function (DeleteRouteRequest) {
    DeleteRouteRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteRouteRequest = exports.DeleteRouteRequest || (exports.DeleteRouteRequest = {}));
var DeleteRouteResponse;
(function (DeleteRouteResponse) {
    DeleteRouteResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteRouteResponse = exports.DeleteRouteResponse || (exports.DeleteRouteResponse = {}));
var DeleteServiceRequest;
(function (DeleteServiceRequest) {
    DeleteServiceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteServiceRequest = exports.DeleteServiceRequest || (exports.DeleteServiceRequest = {}));
var DeleteServiceResponse;
(function (DeleteServiceResponse) {
    DeleteServiceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteServiceResponse = exports.DeleteServiceResponse || (exports.DeleteServiceResponse = {}));
var EnvironmentSummary;
(function (EnvironmentSummary) {
    EnvironmentSummary.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(EnvironmentSummary = exports.EnvironmentSummary || (exports.EnvironmentSummary = {}));
var EnvironmentVpc;
(function (EnvironmentVpc) {
    EnvironmentVpc.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(EnvironmentVpc = exports.EnvironmentVpc || (exports.EnvironmentVpc = {}));
var GetApplicationRequest;
(function (GetApplicationRequest) {
    GetApplicationRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetApplicationRequest = exports.GetApplicationRequest || (exports.GetApplicationRequest = {}));
var GetApplicationResponse;
(function (GetApplicationResponse) {
    GetApplicationResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(GetApplicationResponse = exports.GetApplicationResponse || (exports.GetApplicationResponse = {}));
var GetEnvironmentRequest;
(function (GetEnvironmentRequest) {
    GetEnvironmentRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetEnvironmentRequest = exports.GetEnvironmentRequest || (exports.GetEnvironmentRequest = {}));
var GetEnvironmentResponse;
(function (GetEnvironmentResponse) {
    GetEnvironmentResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(GetEnvironmentResponse = exports.GetEnvironmentResponse || (exports.GetEnvironmentResponse = {}));
var GetResourcePolicyRequest;
(function (GetResourcePolicyRequest) {
    GetResourcePolicyRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetResourcePolicyRequest = exports.GetResourcePolicyRequest || (exports.GetResourcePolicyRequest = {}));
var GetResourcePolicyResponse;
(function (GetResourcePolicyResponse) {
    GetResourcePolicyResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetResourcePolicyResponse = exports.GetResourcePolicyResponse || (exports.GetResourcePolicyResponse = {}));
var GetRouteRequest;
(function (GetRouteRequest) {
    GetRouteRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetRouteRequest = exports.GetRouteRequest || (exports.GetRouteRequest = {}));
var GetRouteResponse;
(function (GetRouteResponse) {
    GetRouteResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(GetRouteResponse = exports.GetRouteResponse || (exports.GetRouteResponse = {}));
var GetServiceRequest;
(function (GetServiceRequest) {
    GetServiceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetServiceRequest = exports.GetServiceRequest || (exports.GetServiceRequest = {}));
var LambdaEndpointConfig;
(function (LambdaEndpointConfig) {
    LambdaEndpointConfig.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(LambdaEndpointConfig = exports.LambdaEndpointConfig || (exports.LambdaEndpointConfig = {}));
var UrlEndpointConfig;
(function (UrlEndpointConfig) {
    UrlEndpointConfig.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UrlEndpointConfig = exports.UrlEndpointConfig || (exports.UrlEndpointConfig = {}));
var GetServiceResponse;
(function (GetServiceResponse) {
    GetServiceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(GetServiceResponse = exports.GetServiceResponse || (exports.GetServiceResponse = {}));
class InvalidResourcePolicyException extends MigrationHubRefactorSpacesServiceException_1.MigrationHubRefactorSpacesServiceException {
    constructor(opts) {
        super({
            name: "InvalidResourcePolicyException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidResourcePolicyException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidResourcePolicyException.prototype);
        this.Message = opts.Message;
    }
}
exports.InvalidResourcePolicyException = InvalidResourcePolicyException;
var LambdaEndpointSummary;
(function (LambdaEndpointSummary) {
    LambdaEndpointSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(LambdaEndpointSummary = exports.LambdaEndpointSummary || (exports.LambdaEndpointSummary = {}));
var ListApplicationsRequest;
(function (ListApplicationsRequest) {
    ListApplicationsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListApplicationsRequest = exports.ListApplicationsRequest || (exports.ListApplicationsRequest = {}));
var ListApplicationsResponse;
(function (ListApplicationsResponse) {
    ListApplicationsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.ApplicationSummaryList && {
            ApplicationSummaryList: obj.ApplicationSummaryList.map((item) => ApplicationSummary.filterSensitiveLog(item)),
        }),
    });
})(ListApplicationsResponse = exports.ListApplicationsResponse || (exports.ListApplicationsResponse = {}));
var ListEnvironmentsRequest;
(function (ListEnvironmentsRequest) {
    ListEnvironmentsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListEnvironmentsRequest = exports.ListEnvironmentsRequest || (exports.ListEnvironmentsRequest = {}));
var ListEnvironmentsResponse;
(function (ListEnvironmentsResponse) {
    ListEnvironmentsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.EnvironmentSummaryList && {
            EnvironmentSummaryList: obj.EnvironmentSummaryList.map((item) => EnvironmentSummary.filterSensitiveLog(item)),
        }),
    });
})(ListEnvironmentsResponse = exports.ListEnvironmentsResponse || (exports.ListEnvironmentsResponse = {}));
var ListEnvironmentVpcsRequest;
(function (ListEnvironmentVpcsRequest) {
    ListEnvironmentVpcsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListEnvironmentVpcsRequest = exports.ListEnvironmentVpcsRequest || (exports.ListEnvironmentVpcsRequest = {}));
var ListEnvironmentVpcsResponse;
(function (ListEnvironmentVpcsResponse) {
    ListEnvironmentVpcsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListEnvironmentVpcsResponse = exports.ListEnvironmentVpcsResponse || (exports.ListEnvironmentVpcsResponse = {}));
var ListRoutesRequest;
(function (ListRoutesRequest) {
    ListRoutesRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListRoutesRequest = exports.ListRoutesRequest || (exports.ListRoutesRequest = {}));
var RouteSummary;
(function (RouteSummary) {
    RouteSummary.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(RouteSummary = exports.RouteSummary || (exports.RouteSummary = {}));
var ListRoutesResponse;
(function (ListRoutesResponse) {
    ListRoutesResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.RouteSummaryList && {
            RouteSummaryList: obj.RouteSummaryList.map((item) => RouteSummary.filterSensitiveLog(item)),
        }),
    });
})(ListRoutesResponse = exports.ListRoutesResponse || (exports.ListRoutesResponse = {}));
var ListServicesRequest;
(function (ListServicesRequest) {
    ListServicesRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListServicesRequest = exports.ListServicesRequest || (exports.ListServicesRequest = {}));
var UrlEndpointSummary;
(function (UrlEndpointSummary) {
    UrlEndpointSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UrlEndpointSummary = exports.UrlEndpointSummary || (exports.UrlEndpointSummary = {}));
var ServiceSummary;
(function (ServiceSummary) {
    ServiceSummary.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(ServiceSummary = exports.ServiceSummary || (exports.ServiceSummary = {}));
var ListServicesResponse;
(function (ListServicesResponse) {
    ListServicesResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.ServiceSummaryList && {
            ServiceSummaryList: obj.ServiceSummaryList.map((item) => ServiceSummary.filterSensitiveLog(item)),
        }),
    });
})(ListServicesResponse = exports.ListServicesResponse || (exports.ListServicesResponse = {}));
var ListTagsForResourceRequest;
(function (ListTagsForResourceRequest) {
    ListTagsForResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForResourceRequest = exports.ListTagsForResourceRequest || (exports.ListTagsForResourceRequest = {}));
var ListTagsForResourceResponse;
(function (ListTagsForResourceResponse) {
    ListTagsForResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(ListTagsForResourceResponse = exports.ListTagsForResourceResponse || (exports.ListTagsForResourceResponse = {}));
var PutResourcePolicyRequest;
(function (PutResourcePolicyRequest) {
    PutResourcePolicyRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(PutResourcePolicyRequest = exports.PutResourcePolicyRequest || (exports.PutResourcePolicyRequest = {}));
var PutResourcePolicyResponse;
(function (PutResourcePolicyResponse) {
    PutResourcePolicyResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(PutResourcePolicyResponse = exports.PutResourcePolicyResponse || (exports.PutResourcePolicyResponse = {}));
var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.Tags && { Tags: smithy_client_1.SENSITIVE_STRING }),
    });
})(TagResourceRequest = exports.TagResourceRequest || (exports.TagResourceRequest = {}));
var TagResourceResponse;
(function (TagResourceResponse) {
    TagResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagResourceResponse = exports.TagResourceResponse || (exports.TagResourceResponse = {}));
var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.TagKeys && { TagKeys: smithy_client_1.SENSITIVE_STRING }),
    });
})(UntagResourceRequest = exports.UntagResourceRequest || (exports.UntagResourceRequest = {}));
var UntagResourceResponse;
(function (UntagResourceResponse) {
    UntagResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UntagResourceResponse = exports.UntagResourceResponse || (exports.UntagResourceResponse = {}));
