import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateEnvironmentRequest, CreateEnvironmentResponse } from "../models/models_0";
import { deserializeAws_restJson1CreateEnvironmentCommand, serializeAws_restJson1CreateEnvironmentCommand, } from "../protocols/Aws_restJson1";
var CreateEnvironmentCommand = (function (_super) {
    __extends(CreateEnvironmentCommand, _super);
    function CreateEnvironmentCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateEnvironmentCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MigrationHubRefactorSpacesClient";
        var commandName = "CreateEnvironmentCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateEnvironmentRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateEnvironmentResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateEnvironmentCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreateEnvironmentCommand(input, context);
    };
    CreateEnvironmentCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreateEnvironmentCommand(output, context);
    };
    return CreateEnvironmentCommand;
}($Command));
export { CreateEnvironmentCommand };
