import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateServiceRequest, CreateServiceResponse } from "../models/models_0";
import { deserializeAws_restJson1CreateServiceCommand, serializeAws_restJson1CreateServiceCommand, } from "../protocols/Aws_restJson1";
var CreateServiceCommand = (function (_super) {
    __extends(CreateServiceCommand, _super);
    function CreateServiceCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateServiceCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MigrationHubRefactorSpacesClient";
        var commandName = "CreateServiceCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateServiceRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateServiceResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateServiceCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreateServiceCommand(input, context);
    };
    CreateServiceCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreateServiceCommand(output, context);
    };
    return CreateServiceCommand;
}($Command));
export { CreateServiceCommand };
