import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteEnvironmentRequest, DeleteEnvironmentResponse } from "../models/models_0";
import { deserializeAws_restJson1DeleteEnvironmentCommand, serializeAws_restJson1DeleteEnvironmentCommand, } from "../protocols/Aws_restJson1";
var DeleteEnvironmentCommand = (function (_super) {
    __extends(DeleteEnvironmentCommand, _super);
    function DeleteEnvironmentCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteEnvironmentCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MigrationHubRefactorSpacesClient";
        var commandName = "DeleteEnvironmentCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteEnvironmentRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DeleteEnvironmentResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteEnvironmentCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteEnvironmentCommand(input, context);
    };
    DeleteEnvironmentCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteEnvironmentCommand(output, context);
    };
    return DeleteEnvironmentCommand;
}($Command));
export { DeleteEnvironmentCommand };
