import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteServiceRequest, DeleteServiceResponse } from "../models/models_0";
import { deserializeAws_restJson1DeleteServiceCommand, serializeAws_restJson1DeleteServiceCommand, } from "../protocols/Aws_restJson1";
var DeleteServiceCommand = (function (_super) {
    __extends(DeleteServiceCommand, _super);
    function DeleteServiceCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteServiceCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MigrationHubRefactorSpacesClient";
        var commandName = "DeleteServiceCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteServiceRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DeleteServiceResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteServiceCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteServiceCommand(input, context);
    };
    DeleteServiceCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteServiceCommand(output, context);
    };
    return DeleteServiceCommand;
}($Command));
export { DeleteServiceCommand };
