import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetEnvironmentRequest, GetEnvironmentResponse } from "../models/models_0";
import { deserializeAws_restJson1GetEnvironmentCommand, serializeAws_restJson1GetEnvironmentCommand, } from "../protocols/Aws_restJson1";
var GetEnvironmentCommand = (function (_super) {
    __extends(GetEnvironmentCommand, _super);
    function GetEnvironmentCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetEnvironmentCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MigrationHubRefactorSpacesClient";
        var commandName = "GetEnvironmentCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetEnvironmentRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetEnvironmentResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetEnvironmentCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1GetEnvironmentCommand(input, context);
    };
    GetEnvironmentCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1GetEnvironmentCommand(output, context);
    };
    return GetEnvironmentCommand;
}($Command));
export { GetEnvironmentCommand };
