import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetRouteRequest, GetRouteResponse } from "../models/models_0";
import { deserializeAws_restJson1GetRouteCommand, serializeAws_restJson1GetRouteCommand, } from "../protocols/Aws_restJson1";
var GetRouteCommand = (function (_super) {
    __extends(GetRouteCommand, _super);
    function GetRouteCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetRouteCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MigrationHubRefactorSpacesClient";
        var commandName = "GetRouteCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetRouteRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetRouteResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetRouteCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1GetRouteCommand(input, context);
    };
    GetRouteCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1GetRouteCommand(output, context);
    };
    return GetRouteCommand;
}($Command));
export { GetRouteCommand };
