import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListEnvironmentVpcsRequest, ListEnvironmentVpcsResponse } from "../models/models_0";
import { deserializeAws_restJson1ListEnvironmentVpcsCommand, serializeAws_restJson1ListEnvironmentVpcsCommand, } from "../protocols/Aws_restJson1";
var ListEnvironmentVpcsCommand = (function (_super) {
    __extends(ListEnvironmentVpcsCommand, _super);
    function ListEnvironmentVpcsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListEnvironmentVpcsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MigrationHubRefactorSpacesClient";
        var commandName = "ListEnvironmentVpcsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListEnvironmentVpcsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListEnvironmentVpcsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListEnvironmentVpcsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListEnvironmentVpcsCommand(input, context);
    };
    ListEnvironmentVpcsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListEnvironmentVpcsCommand(output, context);
    };
    return ListEnvironmentVpcsCommand;
}($Command));
export { ListEnvironmentVpcsCommand };
