import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListEnvironmentsRequest, ListEnvironmentsResponse } from "../models/models_0";
import { deserializeAws_restJson1ListEnvironmentsCommand, serializeAws_restJson1ListEnvironmentsCommand, } from "../protocols/Aws_restJson1";
var ListEnvironmentsCommand = (function (_super) {
    __extends(ListEnvironmentsCommand, _super);
    function ListEnvironmentsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListEnvironmentsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MigrationHubRefactorSpacesClient";
        var commandName = "ListEnvironmentsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListEnvironmentsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListEnvironmentsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListEnvironmentsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListEnvironmentsCommand(input, context);
    };
    ListEnvironmentsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListEnvironmentsCommand(output, context);
    };
    return ListEnvironmentsCommand;
}($Command));
export { ListEnvironmentsCommand };
