import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListRoutesRequest, ListRoutesResponse } from "../models/models_0";
import { deserializeAws_restJson1ListRoutesCommand, serializeAws_restJson1ListRoutesCommand, } from "../protocols/Aws_restJson1";
var ListRoutesCommand = (function (_super) {
    __extends(ListRoutesCommand, _super);
    function ListRoutesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListRoutesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MigrationHubRefactorSpacesClient";
        var commandName = "ListRoutesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListRoutesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListRoutesResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListRoutesCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListRoutesCommand(input, context);
    };
    ListRoutesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListRoutesCommand(output, context);
    };
    return ListRoutesCommand;
}($Command));
export { ListRoutesCommand };
