import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListServicesRequest, ListServicesResponse } from "../models/models_0";
import { deserializeAws_restJson1ListServicesCommand, serializeAws_restJson1ListServicesCommand, } from "../protocols/Aws_restJson1";
var ListServicesCommand = (function (_super) {
    __extends(ListServicesCommand, _super);
    function ListServicesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListServicesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "MigrationHubRefactorSpacesClient";
        var commandName = "ListServicesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListServicesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListServicesResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListServicesCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListServicesCommand(input, context);
    };
    ListServicesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListServicesCommand(output, context);
    };
    return ListServicesCommand;
}($Command));
export { ListServicesCommand };
