import { __assign, __extends } from "tslib";
import { SENSITIVE_STRING } from "@aws-sdk/smithy-client";
import { MigrationHubRefactorSpacesServiceException as __BaseException } from "./MigrationHubRefactorSpacesServiceException";
var AccessDeniedException = (function (_super) {
    __extends(AccessDeniedException, _super);
    function AccessDeniedException(opts) {
        var _this = _super.call(this, __assign({ name: "AccessDeniedException", $fault: "client" }, opts)) || this;
        _this.name = "AccessDeniedException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, AccessDeniedException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return AccessDeniedException;
}(__BaseException));
export { AccessDeniedException };
export var ApiGatewayEndpointType;
(function (ApiGatewayEndpointType) {
    ApiGatewayEndpointType["PRIVATE"] = "PRIVATE";
    ApiGatewayEndpointType["REGIONAL"] = "REGIONAL";
})(ApiGatewayEndpointType || (ApiGatewayEndpointType = {}));
export var ApiGatewayProxyConfig;
(function (ApiGatewayProxyConfig) {
    ApiGatewayProxyConfig.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ApiGatewayProxyConfig || (ApiGatewayProxyConfig = {}));
export var ApiGatewayProxyInput;
(function (ApiGatewayProxyInput) {
    ApiGatewayProxyInput.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ApiGatewayProxyInput || (ApiGatewayProxyInput = {}));
export var ApiGatewayProxySummary;
(function (ApiGatewayProxySummary) {
    ApiGatewayProxySummary.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ApiGatewayProxySummary || (ApiGatewayProxySummary = {}));
export var ApplicationState;
(function (ApplicationState) {
    ApplicationState["ACTIVE"] = "ACTIVE";
    ApplicationState["CREATING"] = "CREATING";
    ApplicationState["DELETING"] = "DELETING";
    ApplicationState["FAILED"] = "FAILED";
    ApplicationState["UPDATING"] = "UPDATING";
})(ApplicationState || (ApplicationState = {}));
export var ErrorCode;
(function (ErrorCode) {
    ErrorCode["INVALID_RESOURCE_STATE"] = "INVALID_RESOURCE_STATE";
    ErrorCode["NOT_AUTHORIZED"] = "NOT_AUTHORIZED";
    ErrorCode["REQUEST_LIMIT_EXCEEDED"] = "REQUEST_LIMIT_EXCEEDED";
    ErrorCode["RESOURCE_CREATION_FAILURE"] = "RESOURCE_CREATION_FAILURE";
    ErrorCode["RESOURCE_DELETION_FAILURE"] = "RESOURCE_DELETION_FAILURE";
    ErrorCode["RESOURCE_IN_USE"] = "RESOURCE_IN_USE";
    ErrorCode["RESOURCE_LIMIT_EXCEEDED"] = "RESOURCE_LIMIT_EXCEEDED";
    ErrorCode["RESOURCE_NOT_FOUND"] = "RESOURCE_NOT_FOUND";
    ErrorCode["RESOURCE_RETRIEVAL_FAILURE"] = "RESOURCE_RETRIEVAL_FAILURE";
    ErrorCode["RESOURCE_UPDATE_FAILURE"] = "RESOURCE_UPDATE_FAILURE";
    ErrorCode["SERVICE_ENDPOINT_HEALTH_CHECK_FAILURE"] = "SERVICE_ENDPOINT_HEALTH_CHECK_FAILURE";
    ErrorCode["STATE_TRANSITION_FAILURE"] = "STATE_TRANSITION_FAILURE";
})(ErrorCode || (ErrorCode = {}));
export var ErrorResourceType;
(function (ErrorResourceType) {
    ErrorResourceType["API_GATEWAY"] = "API_GATEWAY";
    ErrorResourceType["APPLICATION"] = "APPLICATION";
    ErrorResourceType["ENVIRONMENT"] = "ENVIRONMENT";
    ErrorResourceType["IAM_ROLE"] = "IAM_ROLE";
    ErrorResourceType["LAMBDA"] = "LAMBDA";
    ErrorResourceType["LOAD_BALANCER_LISTENER"] = "LOAD_BALANCER_LISTENER";
    ErrorResourceType["NLB"] = "NLB";
    ErrorResourceType["RESOURCE_SHARE"] = "RESOURCE_SHARE";
    ErrorResourceType["ROUTE"] = "ROUTE";
    ErrorResourceType["ROUTE_TABLE"] = "ROUTE_TABLE";
    ErrorResourceType["SECURITY_GROUP"] = "SECURITY_GROUP";
    ErrorResourceType["SERVICE"] = "SERVICE";
    ErrorResourceType["SUBNET"] = "SUBNET";
    ErrorResourceType["TARGET_GROUP"] = "TARGET_GROUP";
    ErrorResourceType["TRANSIT_GATEWAY"] = "TRANSIT_GATEWAY";
    ErrorResourceType["TRANSIT_GATEWAY_ATTACHMENT"] = "TRANSIT_GATEWAY_ATTACHMENT";
    ErrorResourceType["VPC"] = "VPC";
    ErrorResourceType["VPC_ENDPOINT_SERVICE_CONFIGURATION"] = "VPC_ENDPOINT_SERVICE_CONFIGURATION";
    ErrorResourceType["VPC_LINK"] = "VPC_LINK";
})(ErrorResourceType || (ErrorResourceType = {}));
export var ErrorResponse;
(function (ErrorResponse) {
    ErrorResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ErrorResponse || (ErrorResponse = {}));
export var ProxyType;
(function (ProxyType) {
    ProxyType["API_GATEWAY"] = "API_GATEWAY";
})(ProxyType || (ProxyType = {}));
export var ApplicationSummary;
(function (ApplicationSummary) {
    ApplicationSummary.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(ApplicationSummary || (ApplicationSummary = {}));
var ConflictException = (function (_super) {
    __extends(ConflictException, _super);
    function ConflictException(opts) {
        var _this = _super.call(this, __assign({ name: "ConflictException", $fault: "client" }, opts)) || this;
        _this.name = "ConflictException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ConflictException.prototype);
        _this.Message = opts.Message;
        _this.ResourceId = opts.ResourceId;
        _this.ResourceType = opts.ResourceType;
        return _this;
    }
    return ConflictException;
}(__BaseException));
export { ConflictException };
export var CreateApplicationRequest;
(function (CreateApplicationRequest) {
    CreateApplicationRequest.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(CreateApplicationRequest || (CreateApplicationRequest = {}));
export var CreateApplicationResponse;
(function (CreateApplicationResponse) {
    CreateApplicationResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(CreateApplicationResponse || (CreateApplicationResponse = {}));
var InternalServerException = (function (_super) {
    __extends(InternalServerException, _super);
    function InternalServerException(opts) {
        var _this = _super.call(this, __assign({ name: "InternalServerException", $fault: "server" }, opts)) || this;
        _this.name = "InternalServerException";
        _this.$fault = "server";
        Object.setPrototypeOf(_this, InternalServerException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return InternalServerException;
}(__BaseException));
export { InternalServerException };
var ResourceNotFoundException = (function (_super) {
    __extends(ResourceNotFoundException, _super);
    function ResourceNotFoundException(opts) {
        var _this = _super.call(this, __assign({ name: "ResourceNotFoundException", $fault: "client" }, opts)) || this;
        _this.name = "ResourceNotFoundException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ResourceNotFoundException.prototype);
        _this.Message = opts.Message;
        _this.ResourceId = opts.ResourceId;
        _this.ResourceType = opts.ResourceType;
        return _this;
    }
    return ResourceNotFoundException;
}(__BaseException));
export { ResourceNotFoundException };
var ServiceQuotaExceededException = (function (_super) {
    __extends(ServiceQuotaExceededException, _super);
    function ServiceQuotaExceededException(opts) {
        var _this = _super.call(this, __assign({ name: "ServiceQuotaExceededException", $fault: "client" }, opts)) || this;
        _this.name = "ServiceQuotaExceededException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ServiceQuotaExceededException.prototype);
        _this.Message = opts.Message;
        _this.ResourceId = opts.ResourceId;
        _this.ResourceType = opts.ResourceType;
        _this.QuotaCode = opts.QuotaCode;
        _this.ServiceCode = opts.ServiceCode;
        return _this;
    }
    return ServiceQuotaExceededException;
}(__BaseException));
export { ServiceQuotaExceededException };
var ThrottlingException = (function (_super) {
    __extends(ThrottlingException, _super);
    function ThrottlingException(opts) {
        var _this = _super.call(this, __assign({ name: "ThrottlingException", $fault: "client" }, opts)) || this;
        _this.name = "ThrottlingException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ThrottlingException.prototype);
        _this.Message = opts.Message;
        _this.QuotaCode = opts.QuotaCode;
        _this.ServiceCode = opts.ServiceCode;
        _this.RetryAfterSeconds = opts.RetryAfterSeconds;
        return _this;
    }
    return ThrottlingException;
}(__BaseException));
export { ThrottlingException };
var ValidationException = (function (_super) {
    __extends(ValidationException, _super);
    function ValidationException(opts) {
        var _this = _super.call(this, __assign({ name: "ValidationException", $fault: "client" }, opts)) || this;
        _this.name = "ValidationException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ValidationException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ValidationException;
}(__BaseException));
export { ValidationException };
export var NetworkFabricType;
(function (NetworkFabricType) {
    NetworkFabricType["TRANSIT_GATEWAY"] = "TRANSIT_GATEWAY";
})(NetworkFabricType || (NetworkFabricType = {}));
export var CreateEnvironmentRequest;
(function (CreateEnvironmentRequest) {
    CreateEnvironmentRequest.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(CreateEnvironmentRequest || (CreateEnvironmentRequest = {}));
export var EnvironmentState;
(function (EnvironmentState) {
    EnvironmentState["ACTIVE"] = "ACTIVE";
    EnvironmentState["CREATING"] = "CREATING";
    EnvironmentState["DELETING"] = "DELETING";
    EnvironmentState["FAILED"] = "FAILED";
})(EnvironmentState || (EnvironmentState = {}));
export var CreateEnvironmentResponse;
(function (CreateEnvironmentResponse) {
    CreateEnvironmentResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(CreateEnvironmentResponse || (CreateEnvironmentResponse = {}));
export var RouteType;
(function (RouteType) {
    RouteType["DEFAULT"] = "DEFAULT";
    RouteType["URI_PATH"] = "URI_PATH";
})(RouteType || (RouteType = {}));
export var RouteActivationState;
(function (RouteActivationState) {
    RouteActivationState["ACTIVE"] = "ACTIVE";
})(RouteActivationState || (RouteActivationState = {}));
export var HttpMethod;
(function (HttpMethod) {
    HttpMethod["DELETE"] = "DELETE";
    HttpMethod["GET"] = "GET";
    HttpMethod["HEAD"] = "HEAD";
    HttpMethod["OPTIONS"] = "OPTIONS";
    HttpMethod["PATCH"] = "PATCH";
    HttpMethod["POST"] = "POST";
    HttpMethod["PUT"] = "PUT";
})(HttpMethod || (HttpMethod = {}));
export var UriPathRouteInput;
(function (UriPathRouteInput) {
    UriPathRouteInput.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UriPathRouteInput || (UriPathRouteInput = {}));
export var CreateRouteRequest;
(function (CreateRouteRequest) {
    CreateRouteRequest.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(CreateRouteRequest || (CreateRouteRequest = {}));
export var RouteState;
(function (RouteState) {
    RouteState["ACTIVE"] = "ACTIVE";
    RouteState["CREATING"] = "CREATING";
    RouteState["DELETING"] = "DELETING";
    RouteState["FAILED"] = "FAILED";
    RouteState["INACTIVE"] = "INACTIVE";
    RouteState["UPDATING"] = "UPDATING";
})(RouteState || (RouteState = {}));
export var CreateRouteResponse;
(function (CreateRouteResponse) {
    CreateRouteResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(CreateRouteResponse || (CreateRouteResponse = {}));
export var ServiceEndpointType;
(function (ServiceEndpointType) {
    ServiceEndpointType["LAMBDA"] = "LAMBDA";
    ServiceEndpointType["URL"] = "URL";
})(ServiceEndpointType || (ServiceEndpointType = {}));
export var LambdaEndpointInput;
(function (LambdaEndpointInput) {
    LambdaEndpointInput.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(LambdaEndpointInput || (LambdaEndpointInput = {}));
export var UrlEndpointInput;
(function (UrlEndpointInput) {
    UrlEndpointInput.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UrlEndpointInput || (UrlEndpointInput = {}));
export var CreateServiceRequest;
(function (CreateServiceRequest) {
    CreateServiceRequest.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(CreateServiceRequest || (CreateServiceRequest = {}));
export var ServiceState;
(function (ServiceState) {
    ServiceState["ACTIVE"] = "ACTIVE";
    ServiceState["CREATING"] = "CREATING";
    ServiceState["DELETING"] = "DELETING";
    ServiceState["FAILED"] = "FAILED";
})(ServiceState || (ServiceState = {}));
export var CreateServiceResponse;
(function (CreateServiceResponse) {
    CreateServiceResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(CreateServiceResponse || (CreateServiceResponse = {}));
export var DeleteApplicationRequest;
(function (DeleteApplicationRequest) {
    DeleteApplicationRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteApplicationRequest || (DeleteApplicationRequest = {}));
export var DeleteApplicationResponse;
(function (DeleteApplicationResponse) {
    DeleteApplicationResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteApplicationResponse || (DeleteApplicationResponse = {}));
export var DeleteEnvironmentRequest;
(function (DeleteEnvironmentRequest) {
    DeleteEnvironmentRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteEnvironmentRequest || (DeleteEnvironmentRequest = {}));
export var DeleteEnvironmentResponse;
(function (DeleteEnvironmentResponse) {
    DeleteEnvironmentResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteEnvironmentResponse || (DeleteEnvironmentResponse = {}));
export var DeleteResourcePolicyRequest;
(function (DeleteResourcePolicyRequest) {
    DeleteResourcePolicyRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteResourcePolicyRequest || (DeleteResourcePolicyRequest = {}));
export var DeleteResourcePolicyResponse;
(function (DeleteResourcePolicyResponse) {
    DeleteResourcePolicyResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteResourcePolicyResponse || (DeleteResourcePolicyResponse = {}));
export var DeleteRouteRequest;
(function (DeleteRouteRequest) {
    DeleteRouteRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteRouteRequest || (DeleteRouteRequest = {}));
export var DeleteRouteResponse;
(function (DeleteRouteResponse) {
    DeleteRouteResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteRouteResponse || (DeleteRouteResponse = {}));
export var DeleteServiceRequest;
(function (DeleteServiceRequest) {
    DeleteServiceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteServiceRequest || (DeleteServiceRequest = {}));
export var DeleteServiceResponse;
(function (DeleteServiceResponse) {
    DeleteServiceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteServiceResponse || (DeleteServiceResponse = {}));
export var EnvironmentSummary;
(function (EnvironmentSummary) {
    EnvironmentSummary.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(EnvironmentSummary || (EnvironmentSummary = {}));
export var EnvironmentVpc;
(function (EnvironmentVpc) {
    EnvironmentVpc.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(EnvironmentVpc || (EnvironmentVpc = {}));
export var GetApplicationRequest;
(function (GetApplicationRequest) {
    GetApplicationRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetApplicationRequest || (GetApplicationRequest = {}));
export var GetApplicationResponse;
(function (GetApplicationResponse) {
    GetApplicationResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(GetApplicationResponse || (GetApplicationResponse = {}));
export var GetEnvironmentRequest;
(function (GetEnvironmentRequest) {
    GetEnvironmentRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetEnvironmentRequest || (GetEnvironmentRequest = {}));
export var GetEnvironmentResponse;
(function (GetEnvironmentResponse) {
    GetEnvironmentResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(GetEnvironmentResponse || (GetEnvironmentResponse = {}));
export var GetResourcePolicyRequest;
(function (GetResourcePolicyRequest) {
    GetResourcePolicyRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetResourcePolicyRequest || (GetResourcePolicyRequest = {}));
export var GetResourcePolicyResponse;
(function (GetResourcePolicyResponse) {
    GetResourcePolicyResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetResourcePolicyResponse || (GetResourcePolicyResponse = {}));
export var GetRouteRequest;
(function (GetRouteRequest) {
    GetRouteRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetRouteRequest || (GetRouteRequest = {}));
export var GetRouteResponse;
(function (GetRouteResponse) {
    GetRouteResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(GetRouteResponse || (GetRouteResponse = {}));
export var GetServiceRequest;
(function (GetServiceRequest) {
    GetServiceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetServiceRequest || (GetServiceRequest = {}));
export var LambdaEndpointConfig;
(function (LambdaEndpointConfig) {
    LambdaEndpointConfig.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(LambdaEndpointConfig || (LambdaEndpointConfig = {}));
export var UrlEndpointConfig;
(function (UrlEndpointConfig) {
    UrlEndpointConfig.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UrlEndpointConfig || (UrlEndpointConfig = {}));
export var GetServiceResponse;
(function (GetServiceResponse) {
    GetServiceResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(GetServiceResponse || (GetServiceResponse = {}));
var InvalidResourcePolicyException = (function (_super) {
    __extends(InvalidResourcePolicyException, _super);
    function InvalidResourcePolicyException(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidResourcePolicyException", $fault: "client" }, opts)) || this;
        _this.name = "InvalidResourcePolicyException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidResourcePolicyException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return InvalidResourcePolicyException;
}(__BaseException));
export { InvalidResourcePolicyException };
export var LambdaEndpointSummary;
(function (LambdaEndpointSummary) {
    LambdaEndpointSummary.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(LambdaEndpointSummary || (LambdaEndpointSummary = {}));
export var ListApplicationsRequest;
(function (ListApplicationsRequest) {
    ListApplicationsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListApplicationsRequest || (ListApplicationsRequest = {}));
export var ListApplicationsResponse;
(function (ListApplicationsResponse) {
    ListApplicationsResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.ApplicationSummaryList && {
        ApplicationSummaryList: obj.ApplicationSummaryList.map(function (item) { return ApplicationSummary.filterSensitiveLog(item); }),
    }))); };
})(ListApplicationsResponse || (ListApplicationsResponse = {}));
export var ListEnvironmentsRequest;
(function (ListEnvironmentsRequest) {
    ListEnvironmentsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListEnvironmentsRequest || (ListEnvironmentsRequest = {}));
export var ListEnvironmentsResponse;
(function (ListEnvironmentsResponse) {
    ListEnvironmentsResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.EnvironmentSummaryList && {
        EnvironmentSummaryList: obj.EnvironmentSummaryList.map(function (item) { return EnvironmentSummary.filterSensitiveLog(item); }),
    }))); };
})(ListEnvironmentsResponse || (ListEnvironmentsResponse = {}));
export var ListEnvironmentVpcsRequest;
(function (ListEnvironmentVpcsRequest) {
    ListEnvironmentVpcsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListEnvironmentVpcsRequest || (ListEnvironmentVpcsRequest = {}));
export var ListEnvironmentVpcsResponse;
(function (ListEnvironmentVpcsResponse) {
    ListEnvironmentVpcsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListEnvironmentVpcsResponse || (ListEnvironmentVpcsResponse = {}));
export var ListRoutesRequest;
(function (ListRoutesRequest) {
    ListRoutesRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListRoutesRequest || (ListRoutesRequest = {}));
export var RouteSummary;
(function (RouteSummary) {
    RouteSummary.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(RouteSummary || (RouteSummary = {}));
export var ListRoutesResponse;
(function (ListRoutesResponse) {
    ListRoutesResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.RouteSummaryList && {
        RouteSummaryList: obj.RouteSummaryList.map(function (item) { return RouteSummary.filterSensitiveLog(item); }),
    }))); };
})(ListRoutesResponse || (ListRoutesResponse = {}));
export var ListServicesRequest;
(function (ListServicesRequest) {
    ListServicesRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListServicesRequest || (ListServicesRequest = {}));
export var UrlEndpointSummary;
(function (UrlEndpointSummary) {
    UrlEndpointSummary.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UrlEndpointSummary || (UrlEndpointSummary = {}));
export var ServiceSummary;
(function (ServiceSummary) {
    ServiceSummary.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(ServiceSummary || (ServiceSummary = {}));
export var ListServicesResponse;
(function (ListServicesResponse) {
    ListServicesResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.ServiceSummaryList && {
        ServiceSummaryList: obj.ServiceSummaryList.map(function (item) { return ServiceSummary.filterSensitiveLog(item); }),
    }))); };
})(ListServicesResponse || (ListServicesResponse = {}));
export var ListTagsForResourceRequest;
(function (ListTagsForResourceRequest) {
    ListTagsForResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsForResourceRequest || (ListTagsForResourceRequest = {}));
export var ListTagsForResourceResponse;
(function (ListTagsForResourceResponse) {
    ListTagsForResourceResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(ListTagsForResourceResponse || (ListTagsForResourceResponse = {}));
export var PutResourcePolicyRequest;
(function (PutResourcePolicyRequest) {
    PutResourcePolicyRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(PutResourcePolicyRequest || (PutResourcePolicyRequest = {}));
export var PutResourcePolicyResponse;
(function (PutResourcePolicyResponse) {
    PutResourcePolicyResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(PutResourcePolicyResponse || (PutResourcePolicyResponse = {}));
export var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.Tags && { Tags: SENSITIVE_STRING }))); };
})(TagResourceRequest || (TagResourceRequest = {}));
export var TagResourceResponse;
(function (TagResourceResponse) {
    TagResourceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TagResourceResponse || (TagResourceResponse = {}));
export var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.TagKeys && { TagKeys: SENSITIVE_STRING }))); };
})(UntagResourceRequest || (UntagResourceRequest = {}));
export var UntagResourceResponse;
(function (UntagResourceResponse) {
    UntagResourceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UntagResourceResponse || (UntagResourceResponse = {}));
