import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MigrationHubRefactorSpacesClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MigrationHubRefactorSpacesClient";
import { ListEnvironmentVpcsRequest, ListEnvironmentVpcsResponse } from "../models/models_0";
export interface ListEnvironmentVpcsCommandInput extends ListEnvironmentVpcsRequest {
}
export interface ListEnvironmentVpcsCommandOutput extends ListEnvironmentVpcsResponse, __MetadataBearer {
}
/**
 * <p>Lists all Amazon Web Services Migration Hub Refactor Spaces service virtual private clouds (VPCs) that are part of the
 *       environment. </p>
 * @example
 * Use a bare-bones client and the command you need to make an API call.
 * ```javascript
 * import { MigrationHubRefactorSpacesClient, ListEnvironmentVpcsCommand } from "@aws-sdk/client-migration-hub-refactor-spaces"; // ES Modules import
 * // const { MigrationHubRefactorSpacesClient, ListEnvironmentVpcsCommand } = require("@aws-sdk/client-migration-hub-refactor-spaces"); // CommonJS import
 * const client = new MigrationHubRefactorSpacesClient(config);
 * const command = new ListEnvironmentVpcsCommand(input);
 * const response = await client.send(command);
 * ```
 *
 * @see {@link ListEnvironmentVpcsCommandInput} for command's `input` shape.
 * @see {@link ListEnvironmentVpcsCommandOutput} for command's `response` shape.
 * @see {@link MigrationHubRefactorSpacesClientResolvedConfig | config} for MigrationHubRefactorSpacesClient's `config` shape.
 *
 */
export declare class ListEnvironmentVpcsCommand extends $Command<ListEnvironmentVpcsCommandInput, ListEnvironmentVpcsCommandOutput, MigrationHubRefactorSpacesClientResolvedConfig> {
    readonly input: ListEnvironmentVpcsCommandInput;
    constructor(input: ListEnvironmentVpcsCommandInput);
    /**
     * @internal
     */
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MigrationHubRefactorSpacesClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListEnvironmentVpcsCommandInput, ListEnvironmentVpcsCommandOutput>;
    private serialize;
    private deserialize;
}
