import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@aws-sdk/protocol-http";
import { SerdeContext as __SerdeContext } from "@aws-sdk/types";
import { CreateApplicationCommandInput, CreateApplicationCommandOutput } from "../commands/CreateApplicationCommand";
import { CreateEnvironmentCommandInput, CreateEnvironmentCommandOutput } from "../commands/CreateEnvironmentCommand";
import { CreateRouteCommandInput, CreateRouteCommandOutput } from "../commands/CreateRouteCommand";
import { CreateServiceCommandInput, CreateServiceCommandOutput } from "../commands/CreateServiceCommand";
import { DeleteApplicationCommandInput, DeleteApplicationCommandOutput } from "../commands/DeleteApplicationCommand";
import { DeleteEnvironmentCommandInput, DeleteEnvironmentCommandOutput } from "../commands/DeleteEnvironmentCommand";
import { DeleteResourcePolicyCommandInput, DeleteResourcePolicyCommandOutput } from "../commands/DeleteResourcePolicyCommand";
import { DeleteRouteCommandInput, DeleteRouteCommandOutput } from "../commands/DeleteRouteCommand";
import { DeleteServiceCommandInput, DeleteServiceCommandOutput } from "../commands/DeleteServiceCommand";
import { GetApplicationCommandInput, GetApplicationCommandOutput } from "../commands/GetApplicationCommand";
import { GetEnvironmentCommandInput, GetEnvironmentCommandOutput } from "../commands/GetEnvironmentCommand";
import { GetResourcePolicyCommandInput, GetResourcePolicyCommandOutput } from "../commands/GetResourcePolicyCommand";
import { GetRouteCommandInput, GetRouteCommandOutput } from "../commands/GetRouteCommand";
import { GetServiceCommandInput, GetServiceCommandOutput } from "../commands/GetServiceCommand";
import { ListApplicationsCommandInput, ListApplicationsCommandOutput } from "../commands/ListApplicationsCommand";
import { ListEnvironmentsCommandInput, ListEnvironmentsCommandOutput } from "../commands/ListEnvironmentsCommand";
import { ListEnvironmentVpcsCommandInput, ListEnvironmentVpcsCommandOutput } from "../commands/ListEnvironmentVpcsCommand";
import { ListRoutesCommandInput, ListRoutesCommandOutput } from "../commands/ListRoutesCommand";
import { ListServicesCommandInput, ListServicesCommandOutput } from "../commands/ListServicesCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { PutResourcePolicyCommandInput, PutResourcePolicyCommandOutput } from "../commands/PutResourcePolicyCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
export declare const serializeAws_restJson1CreateApplicationCommand: (input: CreateApplicationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateEnvironmentCommand: (input: CreateEnvironmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateRouteCommand: (input: CreateRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateServiceCommand: (input: CreateServiceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteApplicationCommand: (input: DeleteApplicationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteEnvironmentCommand: (input: DeleteEnvironmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteResourcePolicyCommand: (input: DeleteResourcePolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteRouteCommand: (input: DeleteRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteServiceCommand: (input: DeleteServiceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetApplicationCommand: (input: GetApplicationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetEnvironmentCommand: (input: GetEnvironmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetResourcePolicyCommand: (input: GetResourcePolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetRouteCommand: (input: GetRouteCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetServiceCommand: (input: GetServiceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListApplicationsCommand: (input: ListApplicationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListEnvironmentsCommand: (input: ListEnvironmentsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListEnvironmentVpcsCommand: (input: ListEnvironmentVpcsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListRoutesCommand: (input: ListRoutesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListServicesCommand: (input: ListServicesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1PutResourcePolicyCommand: (input: PutResourcePolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const deserializeAws_restJson1CreateApplicationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateApplicationCommandOutput>;
export declare const deserializeAws_restJson1CreateEnvironmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateEnvironmentCommandOutput>;
export declare const deserializeAws_restJson1CreateRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateRouteCommandOutput>;
export declare const deserializeAws_restJson1CreateServiceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateServiceCommandOutput>;
export declare const deserializeAws_restJson1DeleteApplicationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteApplicationCommandOutput>;
export declare const deserializeAws_restJson1DeleteEnvironmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteEnvironmentCommandOutput>;
export declare const deserializeAws_restJson1DeleteResourcePolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteResourcePolicyCommandOutput>;
export declare const deserializeAws_restJson1DeleteRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRouteCommandOutput>;
export declare const deserializeAws_restJson1DeleteServiceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteServiceCommandOutput>;
export declare const deserializeAws_restJson1GetApplicationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetApplicationCommandOutput>;
export declare const deserializeAws_restJson1GetEnvironmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetEnvironmentCommandOutput>;
export declare const deserializeAws_restJson1GetResourcePolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetResourcePolicyCommandOutput>;
export declare const deserializeAws_restJson1GetRouteCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRouteCommandOutput>;
export declare const deserializeAws_restJson1GetServiceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetServiceCommandOutput>;
export declare const deserializeAws_restJson1ListApplicationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListApplicationsCommandOutput>;
export declare const deserializeAws_restJson1ListEnvironmentsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListEnvironmentsCommandOutput>;
export declare const deserializeAws_restJson1ListEnvironmentVpcsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListEnvironmentVpcsCommandOutput>;
export declare const deserializeAws_restJson1ListRoutesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListRoutesCommandOutput>;
export declare const deserializeAws_restJson1ListServicesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListServicesCommandOutput>;
export declare const deserializeAws_restJson1ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
export declare const deserializeAws_restJson1PutResourcePolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutResourcePolicyCommandOutput>;
export declare const deserializeAws_restJson1TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
export declare const deserializeAws_restJson1UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
