import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MigrationHubRefactorSpacesClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MigrationHubRefactorSpacesClient";
import { CreateServiceRequest, CreateServiceResponse } from "../models/models_0";
export interface CreateServiceCommandInput extends CreateServiceRequest {
}
export interface CreateServiceCommandOutput extends CreateServiceResponse, __MetadataBearer {
}

export declare class CreateServiceCommand extends $Command<CreateServiceCommandInput, CreateServiceCommandOutput, MigrationHubRefactorSpacesClientResolvedConfig> {
    readonly input: CreateServiceCommandInput;
    constructor(input: CreateServiceCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MigrationHubRefactorSpacesClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateServiceCommandInput, CreateServiceCommandOutput>;
    private serialize;
    private deserialize;
}
