import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MigrationHubRefactorSpacesClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MigrationHubRefactorSpacesClient";
import { DeleteRouteRequest, DeleteRouteResponse } from "../models/models_0";
export interface DeleteRouteCommandInput extends DeleteRouteRequest {
}
export interface DeleteRouteCommandOutput extends DeleteRouteResponse, __MetadataBearer {
}

export declare class DeleteRouteCommand extends $Command<DeleteRouteCommandInput, DeleteRouteCommandOutput, MigrationHubRefactorSpacesClientResolvedConfig> {
    readonly input: DeleteRouteCommandInput;
    constructor(input: DeleteRouteCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MigrationHubRefactorSpacesClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteRouteCommandInput, DeleteRouteCommandOutput>;
    private serialize;
    private deserialize;
}
