import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MigrationHubRefactorSpacesClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MigrationHubRefactorSpacesClient";
import { DeleteServiceRequest, DeleteServiceResponse } from "../models/models_0";
export interface DeleteServiceCommandInput extends DeleteServiceRequest {
}
export interface DeleteServiceCommandOutput extends DeleteServiceResponse, __MetadataBearer {
}

export declare class DeleteServiceCommand extends $Command<DeleteServiceCommandInput, DeleteServiceCommandOutput, MigrationHubRefactorSpacesClientResolvedConfig> {
    readonly input: DeleteServiceCommandInput;
    constructor(input: DeleteServiceCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MigrationHubRefactorSpacesClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteServiceCommandInput, DeleteServiceCommandOutput>;
    private serialize;
    private deserialize;
}
