import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MigrationHubRefactorSpacesClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MigrationHubRefactorSpacesClient";
import { GetEnvironmentRequest, GetEnvironmentResponse } from "../models/models_0";
export interface GetEnvironmentCommandInput extends GetEnvironmentRequest {
}
export interface GetEnvironmentCommandOutput extends GetEnvironmentResponse, __MetadataBearer {
}

export declare class GetEnvironmentCommand extends $Command<GetEnvironmentCommandInput, GetEnvironmentCommandOutput, MigrationHubRefactorSpacesClientResolvedConfig> {
    readonly input: GetEnvironmentCommandInput;
    constructor(input: GetEnvironmentCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MigrationHubRefactorSpacesClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetEnvironmentCommandInput, GetEnvironmentCommandOutput>;
    private serialize;
    private deserialize;
}
