import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MigrationHubRefactorSpacesClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MigrationHubRefactorSpacesClient";
import { GetRouteRequest, GetRouteResponse } from "../models/models_0";
export interface GetRouteCommandInput extends GetRouteRequest {
}
export interface GetRouteCommandOutput extends GetRouteResponse, __MetadataBearer {
}

export declare class GetRouteCommand extends $Command<GetRouteCommandInput, GetRouteCommandOutput, MigrationHubRefactorSpacesClientResolvedConfig> {
    readonly input: GetRouteCommandInput;
    constructor(input: GetRouteCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MigrationHubRefactorSpacesClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetRouteCommandInput, GetRouteCommandOutput>;
    private serialize;
    private deserialize;
}
