import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MigrationHubRefactorSpacesClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MigrationHubRefactorSpacesClient";
import { GetServiceRequest, GetServiceResponse } from "../models/models_0";
export interface GetServiceCommandInput extends GetServiceRequest {
}
export interface GetServiceCommandOutput extends GetServiceResponse, __MetadataBearer {
}

export declare class GetServiceCommand extends $Command<GetServiceCommandInput, GetServiceCommandOutput, MigrationHubRefactorSpacesClientResolvedConfig> {
    readonly input: GetServiceCommandInput;
    constructor(input: GetServiceCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MigrationHubRefactorSpacesClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetServiceCommandInput, GetServiceCommandOutput>;
    private serialize;
    private deserialize;
}
