import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MigrationHubRefactorSpacesClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MigrationHubRefactorSpacesClient";
import { ListEnvironmentVpcsRequest, ListEnvironmentVpcsResponse } from "../models/models_0";
export interface ListEnvironmentVpcsCommandInput extends ListEnvironmentVpcsRequest {
}
export interface ListEnvironmentVpcsCommandOutput extends ListEnvironmentVpcsResponse, __MetadataBearer {
}

export declare class ListEnvironmentVpcsCommand extends $Command<ListEnvironmentVpcsCommandInput, ListEnvironmentVpcsCommandOutput, MigrationHubRefactorSpacesClientResolvedConfig> {
    readonly input: ListEnvironmentVpcsCommandInput;
    constructor(input: ListEnvironmentVpcsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MigrationHubRefactorSpacesClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListEnvironmentVpcsCommandInput, ListEnvironmentVpcsCommandOutput>;
    private serialize;
    private deserialize;
}
