import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MigrationHubRefactorSpacesClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MigrationHubRefactorSpacesClient";
import { ListEnvironmentsRequest, ListEnvironmentsResponse } from "../models/models_0";
export interface ListEnvironmentsCommandInput extends ListEnvironmentsRequest {
}
export interface ListEnvironmentsCommandOutput extends ListEnvironmentsResponse, __MetadataBearer {
}

export declare class ListEnvironmentsCommand extends $Command<ListEnvironmentsCommandInput, ListEnvironmentsCommandOutput, MigrationHubRefactorSpacesClientResolvedConfig> {
    readonly input: ListEnvironmentsCommandInput;
    constructor(input: ListEnvironmentsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MigrationHubRefactorSpacesClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListEnvironmentsCommandInput, ListEnvironmentsCommandOutput>;
    private serialize;
    private deserialize;
}
