import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { MigrationHubRefactorSpacesClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../MigrationHubRefactorSpacesClient";
import { ListRoutesRequest, ListRoutesResponse } from "../models/models_0";
export interface ListRoutesCommandInput extends ListRoutesRequest {
}
export interface ListRoutesCommandOutput extends ListRoutesResponse, __MetadataBearer {
}

export declare class ListRoutesCommand extends $Command<ListRoutesCommandInput, ListRoutesCommandOutput, MigrationHubRefactorSpacesClientResolvedConfig> {
    readonly input: ListRoutesCommandInput;
    constructor(input: ListRoutesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: MigrationHubRefactorSpacesClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListRoutesCommandInput, ListRoutesCommandOutput>;
    private serialize;
    private deserialize;
}
